﻿/*********************
To implement this feature you need the following:

**********************************************************
** Add a refernce to this script on your page/control:  **
**********************************************************
<script src="Util/popupchecker.js?v=1" type="text/javascript"></script>

********************************************
** Add this script on your page/control:  **
********************************************

<script type="text/javascript" defer="defer" src="util/popupcontrol.js"></script>

******************************************
** Add this htm page in your project    **
** referenced in your window.open call  **
******************************************

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
<title>Popup Window Test</title>
<script language="javascript" type="text/javascript">function test(){}</script>

</head>
<body>
Successful popup window test.
<a href="javascript: window.close()">Click here </a>to close this window.
</body>
</html>

*****************
**    NOTES    **
*****************

IF YOU NEED THE SCRIPT TO NOT EXECUTE UNDER CERTAIN CIRCUMSTANCES
ADD THE popuptest_disabled VAR TO THE PAGE WHEN YOU NEED IT SHUT OFF

THE DEFER PROPERTY ON THE JAVASCRIPT IS IMPORTANT FOR THE popuptest_disabled VAR TO WORK.
THE DEFER PROPERTY WON'T WORK AT ALL IN SOME BROWSERS WITH EMBEDDED SCRIPT.
IT HAS TO BE A SCRIPT TAG WITH A SRC.

popuptest_disabled EXAMPLE:
In an event handler that writes a javascript to the page in response to an event you could add the following script:
this.Page.ClientScript.RegisterStartupScript(this.GetType(), "sRegister", "var popuptest_disabled=true; var target=GetNamedElementReference('" + b1.ClientID + "'); target.click();", true);
The page script will see the variable and not execute the popup test.

***********************/

/*
Set cookie to show that this has been checked.
*/
function setCookie(c_name, value, exdays) {
    var exdate = new Date();
    exdate.setDate(exdate.getDate() + exdays);
    var c_value = escape(value) + ((exdays == null) ? "" : "; expires=" + exdate.toUTCString());
    document.cookie = c_name + "=" + c_value;
}

function getCookie(c_name) {
    var i, x, y, ARRcookies = document.cookie.split(";");
    for (i = 0; i < ARRcookies.length; i++) {
        x = ARRcookies[i].substr(0, ARRcookies[i].indexOf("="));
        y = ARRcookies[i].substr(ARRcookies[i].indexOf("=") + 1);
        x = x.replace(/^\s+|\s+$/g, "");
        if (x == c_name) {
            return unescape(y);
        }
    }
}

function checkCookie() {
    var result = false;
    var popupck = getCookie("popup");
    if (popupck != null && popupck != "notblocked") {
        //
        result = false;
    }
    else {
        result = true;
    }
    return result;
}

/*
Checks to see if the poppedWindow exists
Return true if it doesn't exist else return false
*/
function doCheckPopupBlocked(poppedWindow) {
    var result = false;

    //if (checkCookie()) {
    try {
        if (typeof poppedWindow == 'undefined') {
            // Safari with popup blocker... leaves the popup window handle undefined
            result = true;
        }
        else if (poppedWindow && poppedWindow.closed) {
            // This happens if the user opens and closes the client window...
            result = false;
        }
        else if (poppedWindow && poppedWindow.outerWidth == 0) {
            // This is usually Chrome's doing. The outerWidth (and most other size/location info)
            // will be left at 0, EVEN THOUGH the contents of the popup will exist (including the
            // test function we check for next). The outerWidth starts as 0, so a sufficient delay
            // after attempting to pop is needed.
            result = true;
        }
        else if (poppedWindow && poppedWindow.test) {
            // This is the actual test. The client window should be fine.
            result = false;
        }
        else {
            // Else we'll assume the window is not OK
            result = true;
        }
    } catch (err) {
        //if (console) {
        // console.warn("Could not access popup window", err);
        //}
    }

    if (!result)
        setCookie("popup", "blocked", 1)
    else
        setCookie("popup", "notblocked", 1);
    /*}
    else {
    result = true;
    }*/
    return result;
}

// shows/hides input object
function ShowHide(obj, show_or_hide) {
    var objRef = GetNamedElementReference(obj);
    if (exists(objRef))
        if (show_or_hide == 'show')
        objRef.style.display = "block";
    else if (show_or_hide == 'hide')
        objRef.style.display = "none";
}

// verifies that an object exists
function exists(obj) {
    return (obj != null && typeof (obj) != 'undefined');
}

//Gets a reference to a named element
var dom = document.getElementById && !document.all ? 1 : 0;
function GetNamedElementReference(pElementID) {
    var id = pElementID.replace(/\//g, "_");
    id = id.replace(/\$/g, "_");
    return dom ? document.getElementById(id) : document.all[id];
}